function vexalarm.panel_spells(ID)
				
	local grps = {
		{"General Settings", 1},
		{"Buffs", 2},
		{"Selfbuffs", 3},
		{"Groupbuffs", 4},
		{"Casts with targets", 5},
		{"Casts without targets", 6},
		}
	
	local classnames = {"DEATHKNIGHT", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR", ""}
	local rolenames = {"all", "tank", "heal", "dd", "role not set"}
	local orderStartvalue = 100
	local enable = {
			{"+", "enable", true},
			{"-", "disable", false}
			}
			
	local definitiontexts = {"",
			"Listed 'buff'-spells are buffs that have a single target",
			"Listed 'selfbuff'-spells are buffs that have no target and are mostly casted on yourself",
			"Listed 'grpbuff'-spells are buffs that effect multiple targets",
			"Listed 'cast'-spells are spells that have a target",
			"Listed 'selfcast'-spells are spells that have no target and are mostly casted on yourself",
			}
	
	local options = {
		type = "group",
		args = {
			newspells = {name = "If you're missing a spell and want it added to the list, feel free to contact me\nhttp://www.wowace.com/addons/cdalarm\n",
					type="description", fontSize="medium", order=1},
			definitiongrp = { name = "Definition", type="group", order= 2, dialogInline = true,
				args = { definitiontext = {name = definitiontexts[ID], type="description", fontSize="medium", order=1}, },
				}
			}
		}
	
	
	local optiongrp = {
		name = grps[ID][1], type = "group", dialogInline = true, args = {}, order=ID+10,
		}
		
	local rank = 0
	local tablenumber = ID-1
	
	-- +/- buttons
	for i=1,5 do
		for j=1,2 do
			if i == 1 then 	role = nil		rank = (j*15)+1
			else 			role = i 		rank = i+(10*j) end
			optiongrp.args[tostring(ID).."_"..enable[j][2].."_role_"..tostring(i)] = vexalarm_spelloptions_button(rolenames[i], tablenumber, enable[j], role, rank)
		end
	end
	optiongrp.args[tostring(ID).."space3"] = {name = "\n\n\n", type="description", order=33}
	local temp = {}
	if 		tablenumber == 1 	then temp = vexalarm_buffs_defaults
	elseif 	tablenumber == 2 	then temp = vexalarm_selfbuffs_defaults
	elseif 	tablenumber == 3 	then temp = vexalarm_grpbuffs_defaults
	elseif 	tablenumber == 4 	then temp = vexalarm_instants_defaults
	elseif 	tablenumber == 5 	then temp = vexalarm_instantsself_defaults end
	
	local spellrank = 0
	
	for i=1,#classnames do
		for j=1,#temp do	
			if temp[j][6] == classnames[i] then
				spellrank = spellrank + 1
				rank = (spellrank*10)+100
				optiongrp.args[tostring(rank)] = vexalarm_spelloptions_description(tablenumber, j, rank)
				
				for z=1,4 do
					optiongrp.args[tostring(rank+z)] = vexalarm_spelloptions_toggle(rolenames[z+1], tablenumber, j, z, rank+z)
				end
						
				optiongrp.args[tostring(rank+5)] = {name = "\n", type="description", order=rank+5}	
			end
		end
	end
		
	options.args[grps[ID][1]] = optiongrp

	return options
end



function vexalarm_spelloptions_button(rolestring, tablenumber, enable, role, rank)
	local returnvalue = {
		name = enable[1].." "..rolestring,
		func = function(info,val) vexalarm_spelltoggle(tablenumber, enable[3], role) end,
		order=rank, type = "execute",}
	if role~=5 then returnvalue.width="half" end
	if role == nil then returnvalue.desc = enable[2].." all spells"
	else 				returnvalue.desc = enable[2].." all spells where the caster's role is '"..rolestring.."'" end
	return returnvalue
end

function vexalarm_spelloptions_description(tablenumber, key, rank)
	local temp = {}
	if 		tablenumber == 1 	then temp = vexalarm_buffs_defaults[key]
	elseif 	tablenumber == 2 	then temp = vexalarm_selfbuffs_defaults[key]
	elseif 	tablenumber == 3 	then temp = vexalarm_grpbuffs_defaults[key]
	elseif 	tablenumber == 4 	then temp = vexalarm_instants_defaults[key]
	elseif 	tablenumber == 5 	then temp = vexalarm_instantsself_defaults[key] end
	local iconfile = select(3, GetSpellInfo(temp[1]))
	local spellname = select(1, GetSpellInfo(temp[1]))
	local spellid = temp[6]
	return {fontSize="large", image = iconfile, name = vexalarm_colorize_class(spellname, false, spellid), type="description", order=rank}
end

function vexalarm_spelloptions_toggle(rolestring, tablenumber, key, role, rank)	
	local returnvalue = {
						name = rolestring,
						order=rank, type = "toggle", width="half",
						desc = "Shall Vex Alarm post an alarm when the caster's role is "..rolestring,
						set = function(info,val) vexalarm_spelltoggle_set(tablenumber, key, role, val) end,
						get = function() return vexalarm_spelltoggle_get(tablenumber, key, role) end	
						}
	
	if rank ~= 5 then returnvalue.width="half" end
	return returnvalue
end

function vexalarm_spelltoggle_get(tablenumber, key, role)
	if 		tablenumber == 1 	then return vexalarm_buffs[key][role+1]
	elseif 	tablenumber == 2 	then return vexalarm_selfbuffs[key][role+1]
	elseif 	tablenumber == 3 	then return vexalarm_grpbuffs[key][role+1]
	elseif 	tablenumber == 4 	then return vexalarm_instants[key][role+1]
	elseif 	tablenumber == 5 	then return vexalarm_instantsself[key][role+1] end
end


function vexalarm_spelltoggle_set(tablenumber, key, role, val)
	if 		tablenumber == 1 	then vexalarm_buffs[key][role+1] = val
	elseif 	tablenumber == 2 	then vexalarm_selfbuffs[key][role+1] = val
	elseif 	tablenumber == 3 	then vexalarm_grpbuffs[key][role+1] = val
	elseif 	tablenumber == 4 	then vexalarm_instants[key][role+1] = val
	elseif 	tablenumber == 5 	then vexalarm_instantsself[key][role+1] = val end
end


function vexalarm_spelltoggle(tablenumber, val, role)
	if tablenumber ~= nil then
		if tablenumber == 1 then
			for i=1,#vexalarm_buffs do
				if role ~= nil then vexalarm_buffs[i][role] = val
				else
					for j=2,5 do
						vexalarm_buffs[i][j] = val
					end
				end
			end
		elseif tablenumber == 2 then
			for i=1,#vexalarm_selfbuffs do
				if role ~= nil then vexalarm_selfbuffs[i][role] = val
				else
					for j=2,5 do
						vexalarm_selfbuffs[i][j] = val
					end
				end
			end
		elseif tablenumber == 3 then
			for i=1,#vexalarm_grpbuffs do
				if role ~= nil then vexalarm_grpbuffs[i][role] = val
				else
					for j=2,5 do
						vexalarm_grpbuffs[i][j] = val
					end
				end
			end
		elseif tablenumber == 4 then
			for i=1,#vexalarm_instants do
				if role ~= nil then vexalarm_instants[i][role] = val
				else
					for j=2,5 do
						vexalarm_instants[i][j] = val
					end
				end
			end
		elseif tablenumber == 5 then
			for i=1,#vexalarm_instantsself do
				if role ~= nil then vexalarm_instantsself[i][role] = val
				else
					for j=2,5 do
						vexalarm_instantsself[i][j] = val
					end
				end
			end
		end
	else
		for i=1,5 do
			vexalarm_spelltoggle(i, val, role)
		end
	end
end

