vexalarm = {}
vexalarm.AceConfigDialog = LibStub("AceConfigDialog-3.0", true)
vexalarm.AceConfig = LibStub("AceConfig-3.0", true);
vexalarm.AceConsole= LibStub("AceConsole-3.0", true);
vexalarm.LSM = LibStub("LibSharedMedia-3.0", true);
vexalarm.LSMWidgets = LibStub("AceGUI-3.0-SharedMediaWidgets", true);

--Start values
vexalarm.infight = false
vexalarm.proclaim_timestamps = {}
vexalarm.proclaim_texts ={}
vexalarm.last_spell_id = ""
vexalarm.last_spell_timestamp = 0
vexalarm.last_spell_event = ""
vexalarm.show = true
vexalarm.printouts = {false, false}
vexalarm.loadings = 0

SLASH_VEXALARM1 = "/vexalarm"
SLASH_VEXALARM2 = "/vexa"
function SlashCmdList.VEXALARM(msg, editbox)
	if msg == "reset" then
		vexalarm_frame_bg:SetPoint("TOPLEFT", 600, -300)
		print("|CFFFF7D0AVex Alarm|r - frame has been reset")
	elseif msg == "option" then		InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel);
	elseif msg == "options" then	InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel);
	elseif msg == "config" then		InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel);
	elseif msg == "configs" then	InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel);
	elseif msg == "print" then 		vexalarm_print_variables()
	elseif msg == "defaults" then
		print("|CFFFF7D0AVex Alarm|r - defaults loaded")
		vexalarm_loaddefaults(true)
	elseif msg == "enable" then
		if vexalarm_parameters["enable"] then	vexalarm_parameters["enable"]=false vexalarm_checkshow() print("|CFFFF7D0AVex Alarm|r - Addon disabled")
		else 									vexalarm_parameters["enable"]=true  vexalarm_checkshow() print("|CFFFF7D0AVex Alarm|r - Addon enabled") end
	else
		print ("|CFFFF7D0Avexalarm|r cmd list - /vexalarm and /cda can be used")
		print ("|CFFFF7D0A/vexalarm|r reset - resets the frameposition")
		print ("|CFFFF7D0A/vexalarm|r option/options/config/configs - opens the option frame")
		print ("|CFFFF7D0A/vexalarm|r defaults - resets the addon to defaults")
		print ("|CFFFF7D0A/vexalarm|r enable - enables/disables the addon")
	end
end

function vexalarm_OnEvent(self, event, ...)
	if event == "PLAYER_LOGIN" then
		vexalarm_initialize()
		print("|CFFFF7D0AVex Alarm|r loaded")
	elseif event == "PLAYER_ENTER_COMBAT" then
		vexalarm_infight = true
		vexalarm_checkshow()
	elseif event == "PLAYER_LEAVE_COMBAT" then
		vexalarm_infight = false
		vexalarm_checkshow()
	else
		if vexalarm.show then
			vexalarm_check_fulltext()
			local eventchar  = select(2, ...)
			if eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_AURA_REMOVED" then
				alarmtype = vexalarm_spellcheck(select(12, ...),  select(5, ...), eventchar)
				if(alarmtype ~="" and alarmtype ~="dejavue") then
					vexalarm_proclaim(alarmtype, select(13, ...), select(5, ...), select(9, ...), eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_CAST_SUCCESS")
				end
			end
		end
	end
end

function vexalarm_initialize(reload)
	vexalarm_loaddefaults(false)
	vexalarm_checkshow()
	vexalarm_set_frame_bg()
	if not(reload) then 
		vexalarm_optionpanel_OnLoad()
		for i=1,38 do
			if i<10 then	k = "0"..i
			else			k = ""..i end
			vexalarm.LSM:Register("sound", k, "Interface\\AddOns\\vexalarm\\sounds\\button_"..i..".ogg")
		end
		vexalarm.LSM:Register("border", "Solid", "Interface\\Buttons\\WHITE8X8")
	end
end

function vexalarm_set_frame_bg()
	vexalarm_frame_bg:SetWidth(vexalarm_parameters["frame"]["size"]["width"])
	vexalarm_frame_bg:SetHeight(vexalarm_parameters["frame"]["size"]["height"])
	vexalarm_frame_bg:SetPoint("TOPLEFT",
				UIParent,
				vexalarm_parameters["frame"]["position"]["bg"]["anchor"],
				vexalarm_parameters["frame"]["position"]["bg"]["x"],
				vexalarm_parameters["frame"]["position"]["bg"]["y"])
	vexalarm_frame_bg:SetBackdrop({bgFile=vexalarm.LSM:Fetch("background", vexalarm_parameters["frame"]["bg"]["texture"]),
								edgeFile=vexalarm.LSM:Fetch("border", vexalarm_parameters["frame"]["border"]["texture"]), tile=false,
								edgeSize=vexalarm_parameters["frame"]["border"]["size"]})
	vexalarm_frame_bg:SetBackdropColor(	vexalarm_parameters["frame"]["bg"]["color"]["r"],
										vexalarm_parameters["frame"]["bg"]["color"]["g"],
										vexalarm_parameters["frame"]["bg"]["color"]["b"],
										vexalarm_parameters["frame"]["bg"]["color"]["a"])
	vexalarm_frame_bg:SetBackdropBorderColor(	vexalarm_parameters["frame"]["border"]["color"]["r"],
												vexalarm_parameters["frame"]["border"]["color"]["g"],
												vexalarm_parameters["frame"]["border"]["color"]["b"],
												vexalarm_parameters["frame"]["border"]["color"]["a"])
end

function vexalarm_checkshow()
	if vexalarm_parameters["enable"] then
		if 		vexalarm_parameters["showonlyinfight"] and vexalarm.infight 	then vexalarm.show = true
		elseif 	vexalarm_parameters["showonlyinfight"] and not(vexalarm.infight) then vexalarm.show = false
		else vexalarm.show = true end
	else vexalarm.show = false end
	
	if vexalarm.show then vexalarm_frame_bg:Show()
	else vexalarm_frame_bg:Hide() end
	
end



